import "dynamsoft-document-normalizer";
import { WebPlugin } from '@capacitor/core';
import type { Quadrilateral } from "dynamsoft-core";
import type { DetectedQuadResultItem } from 'dynamsoft-document-normalizer';
import type { DocumentNormalizerPlugin, NormalizedImageResult } from './definitions';
export declare class DocumentNormalizerWeb extends WebPlugin implements DocumentNormalizerPlugin {
    private cvr;
    private engineResourcePaths;
    initialize(): Promise<void>;
    initLicense(options: {
        license: string;
    }): Promise<void>;
    setEngineResourcePaths(options: {
        paths: any;
    }): Promise<void>;
    initRuntimeSettingsFromString(options: {
        template: string;
    }): Promise<void>;
    detect(options: {
        source: string | HTMLImageElement | HTMLCanvasElement;
        template?: string;
    }): Promise<{
        results: DetectedQuadResultItem[];
    }>;
    detectFile(_options: {
        path: string;
        template?: string | undefined;
    }): Promise<{
        results: DetectedQuadResultItem[];
    }>;
    detectBitmap(): Promise<{
        results: DetectedQuadResultItem[];
    }>;
    normalizeFile(_options: {
        path: string;
        quad: Quadrilateral;
        template?: string;
        saveToFile?: boolean;
        includeBase64?: boolean;
    }): Promise<{
        result: NormalizedImageResult;
    }>;
    normalize(options: {
        source: string | HTMLImageElement | HTMLCanvasElement;
        quad: Quadrilateral;
        template?: string;
        saveToFile?: boolean;
        includeBase64?: boolean;
    }): Promise<{
        result: NormalizedImageResult;
    }>;
    detectAndNormalize(options: {
        path?: string | undefined;
        source?: string | HTMLImageElement | HTMLCanvasElement | undefined;
        template?: string | undefined;
        saveToFile?: boolean | undefined;
        includeBase64?: boolean | undefined;
    }): Promise<{
        result: NormalizedImageResult;
    }>;
    removeDataURLHead(dataURL: string): string;
}
